/****************************************************************************
 *                             S Y S T R A Y / 2                            *
 *                           Default Plugin Module                          *
 *                                                                          *
 * (C) 2000-1, Russian Team OS/2.                      All Rights Reserved  *
 * Written by Dmitry Zaharov                http://os2.ru/projects/systray  *
 ****************************************************************************/

/* Swap file monitor */

#include "..\systray.h"
#include <dos.h>
#include <ctype.h>
#include "plugin.h"

char    szPop3Class[] = "SystrayPOP3MonitorClass";
char    szPop3Help[] = "Pop3 mailbox status monitor";

extern HAB     habMain;
extern HMODULE hmod;
extern HWND    hwndDefPopup;
extern HPOINTER hptrExe;

HPOINTER hptrPop3IconEmpty,hptrPop3IconNew;
HWND hwndMailPopup;

typedef struct _UNITPOP3MON {
UNIT    unit;
BYTE    bZero;
UPPR    uppr;
ULONG   minutes;
BOOL    alarmnew;
CHAR    szUser[32];
CHAR    szPassword[32];
CHAR    szHostname[100];
USHORT  usPort;
ULONG   hEventSem;
CHAR    messagebuf[256];
ULONG   nmsg, msgsize, oldnmsg;
BOOL    termflag;
BOOL    newmail;
SHORT   state;
BOOL	runclient;
CHAR	szProgram[100];
} UNITPOP3MON;

#define WM_POP3STATE (WM_USER+3)

#define POP3MON_OK  0
#define POP3MON_BAD -1

typedef UNITPOP3MON *PUNITPOP3MON;

PUNITPOP3MON punittemp;

#include <netdb.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>

/* IN SO32.DLL */

typedef int ( _System SO_socket ) ( int domain, int type, int protocol );
typedef int ( _System SO_soclose ) ( int socket_n );
typedef int ( _System SO_soioctl ) ( int socket_n, int cmd, char buf, int length );
typedef int ( _System SO_connect ) ( int socket_n, struct sockaddr *s_name, int namelength );
typedef int ( _System SO_recv) ( int socket_n, char *buf, int length, int flags );
typedef int ( _System SO_send ) ( int socket_n, char *buf, int length, int flags );

SO_socket*          _socket = NULL;
SO_soclose*         _soclose = NULL;
SO_soioctl*         _soioctl = NULL;
SO_connect*         _connect = NULL;
SO_recv*            _recv = NULL;
SO_send*            _send = NULL;

/* IN TCP32.DLL */

typedef unsigned long ( _System TCP_inet_addr ) ( char *addr );
typedef struct hostent * ( _System TCP_gethostbyname ) ( char *hostname );
typedef unsigned short ( _System TCP_bswap ) ( unsigned short value );

TCP_inet_addr*     _inet_addr = NULL;
TCP_gethostbyname* _gethostbyname = NULL;
TCP_bswap*         _bswap = NULL;

HMODULE hmSo32 = NULLHANDLE, hmTcp32 = NULLHANDLE;

char aStack[32768];

/* LOOKUP TABLE */

char *aInetCalls[9] =
{
  "INET_ADDR", "GETHOSTBYNAME", "BSWAP",
  "SOCKET",    "SOCLOSE",       "IOCTL",
  "CONNECT",   "RECV",          "SEND"
};

PFN* aInetFuncs[9] =
{
  /* TCP32 */
  ( PFN* ) &_inet_addr,
  ( PFN* ) &_gethostbyname,
  ( PFN* ) &_bswap,
  /* SO32 */
  ( PFN* ) &_socket,
  ( PFN* ) &_soclose,
  ( PFN* ) &_soioctl,
  ( PFN* ) &_connect,
  ( PFN* ) &_recv,
  ( PFN* ) &_send
};

int  log(char *s)
{
/*FILE *f;
f=fopen("pop3log","at");
fprintf(f,"%s\n",s);
fclose(f);*/
return 0;
}

int  recvline( int socket_n, char *buf )
{
int i = 1;
char *t, ch = 0;
t = buf;
do {
   if( _recv(socket_n, &ch, 1, 0) < 1 ) return (-1);
   /* Skip line-feed and carriage-return characters */
   if( (ch != '\n') && (ch != '\r') ) { *buf = ch; buf++; }
} while ( ch != '\n' );
*buf = '\0';
return strlen(t);
}

int  sendline(int socket_n, char *buf)
{
char crlf[] = "\r\n";
int  i;
if( (i = _send(socket_n, buf, strlen(buf), 0)) <= 0 ) return i;
if( (i = _send(socket_n, crlf, strlen(crlf), 0)) <= 0 ) return i;
return strlen(buf);
}

void pop3scanthread(void FAR* pv)
{
UNITPOP3MON * FAR *args = (UNITPOP3MON**) pv;
PUNITPOP3MON punit;
ULONG ulTemp = 0, ulIpAddr = 0;
int socket_n = 0;
struct hostent *hp;
struct sockaddr_in sa;
char           buffer[512];
char           popquit[] = "QUIT";

punit = (PUNITPOP3MON)pv;

while(1)
{
DosWaitEventSem( punit->hEventSem, -1L );
DosResetEventSem( punit->hEventSem, &ulTemp );

if( punit->termflag ) break;
if( !punit->szHostname[0] ) continue;

ulIpAddr = _inet_addr( punit->szHostname );

if( ulIpAddr == 0xFFFFFFFFUL )
{
hp = _gethostbyname( punit->szHostname );
if( hp ) ulIpAddr = *( unsigned long* ) hp->h_addr;
else
{
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}

if( ulIpAddr == 0xFFFFFFFFUL )
{
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}

}
socket_n = _socket( AF_INET, SOCK_STREAM, 0 );

if( socket_n == -1 )
{
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}

/* Connect to given ip */

memset( &sa, 0, sizeof ( sa ) );
sa.sin_family = AF_INET;
sa.sin_addr.s_addr = ulIpAddr;
sa.sin_port = _bswap( punit->usPort );

_connect( socket_n, ( struct sockaddr* ) &sa, sizeof ( sa ) );

if( recvline( socket_n, buffer) <= 0 )
{
/* log(buffer) */;
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
log(buffer);
/* Do login */

sprintf( buffer, "USER %s", punit->szUser );

if( sendline( socket_n, buffer ) <=0 )
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
/* log(buffer) */;
if( recvline( socket_n, buffer) <= 0 )
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
log(buffer);
if( buffer[0] == '-' ) /* error */
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}

/* Send password */

sprintf( buffer, "PASS %s", punit->szPassword );

if( sendline( socket_n, buffer ) <=0 )
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
log(buffer);
if( recvline( socket_n, buffer) <= 0 )
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
/* log(buffer) */;
if( buffer[0] == '-' ) /* error */
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
/* log(buffer) */;
/* send status request */

if( sendline( socket_n, "STAT" ) <=0 )
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
log(buffer);
if( recvline( socket_n, buffer) <= 0 )
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
/* log(buffer) */;
if( buffer[0] == '-' ) /* error */
{
/* log(buffer) */;
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_BAD;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );
continue;
}
/* log(buffer) */;
strcpy( punit->messagebuf, buffer );
sendline( socket_n, popquit );
_soclose( socket_n );
punit->state = POP3MON_OK;
WinPostMsg( punit->unit.hwnd, WM_POP3STATE, NULL, NULL );

}
DosCloseEventSem(punit->hEventSem);
DosFreeMem((PVOID)punit);
_endthread();
}

/* externs in toolbar.c */
int openfile(HWND hwnd,char *name,char *title);
void executetool(char * prog,char * arg,char * dir);
/* */

MRESULT EXPENTRY pop3mondlgproc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
static PUNITPOP3MON punit;
BTNCDATA bcd = { sizeof(BTNCDATA), 0L, 0L, NULLHANDLE };
SWP swp;
char buf[256];
switch(msg)
{
case WM_INITDLG:
punit = (PUNITPOP3MON)mp2;
WinSetWindowText( WinWindowFromID( hwnd, 902), punit->szHostname );
itoa( punit->usPort, buf, 10 );
WinSetWindowText( WinWindowFromID( hwnd, 903), buf);
WinSetWindowText( WinWindowFromID( hwnd, 904), punit->szUser);
WinSetWindowText( WinWindowFromID( hwnd, 905), punit->szPassword);
WinSendDlgItemMsg( hwnd, 908, SPBM_SETLIMITS, (MPARAM)255L, (MPARAM)1L );
WinSendDlgItemMsg( hwnd, 908, SPBM_SETCURRENTVALUE,(MPARAM)punit->minutes, (MPARAM)0L );
WinCheckButton( hwnd, 909, punit->alarmnew );
WinCheckButton( hwnd, 910, punit->runclient );
WinQueryWindowPos( WinWindowFromID( hwnd, 911 ), &swp );
WinDestroyWindow( WinWindowFromID( hwnd, 911 ) );
bcd.hImage = hptrExe;
WinCreateWindow( hwnd, WC_BUTTON, "", BS_PUSHBUTTON | BS_MINIICON |
		 WS_VISIBLE | WS_GROUP | WS_TABSTOP,  swp.x, swp.y,
		 swp.cx, swp.cy, hwnd, HWND_TOP, 911, (PVOID)&bcd, NULL );
break;
case WM_CONTROL:
if((SHORT1FROMMP(mp1) == 908) && (SHORT2FROMMP(mp1) == SPBN_CHANGE))
   WinSendDlgItemMsg( hwnd, 908, SPBM_QUERYVALUE,
                      (MPARAM)buf, MPFROM2SHORT( 0, SPBQ_UPDATEIFVALID ) );
break;
case WM_COMMAND:
if((SHORT)mp1==911)
{
strcpy(buf,"*.EXE");
if( openfile( hwnd, buf, "Set e-mail client program" ) )
   strcpy( punit->szProgram, buf );
return NULL;
}
if((SHORT)mp1==DID_OK)
{
WinQueryWindowText( WinWindowFromID( hwnd, 902), 32, punit->szHostname );
WinQueryWindowText( WinWindowFromID( hwnd, 903), 32, buf);
WinSendDlgItemMsg( hwnd, 908, SPBM_QUERYVALUE,
                   (MPARAM)&punit->minutes, MPFROM2SHORT( 0, SPBQ_UPDATEIFVALID ) );
sscanf(buf,"%i",&punit->usPort);
WinQueryWindowText( WinWindowFromID( hwnd, 904), 32, punit->szUser);
WinQueryWindowText( WinWindowFromID( hwnd, 905), 32, punit->szPassword);
punit->alarmnew = WinQueryButtonCheckstate( hwnd, 909 );
punit->runclient = WinQueryButtonCheckstate( hwnd, 910 );
punit->unit.ulRefresh = punit->minutes*60L;
punit->unit.ulCounter = punit->minutes*60L-1L;
}
break;
}
return WinDefDlgProc(hwnd,msg,mp1,mp2);
}

MRESULT EXPENTRY pop3monwndproc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
PUNITPOP3MON punit;
UNITPOP3MON *args[2];
HPS hps;
RECTL rcl;
char buf[80];
punit = (PUNITPOP3MON)WinQueryWindowULong(hwnd,0L);
switch(msg)
{
case WM_CREATE:
punit = (PUNITPOP3MON)mp1;
WinSetWindowULong(hwnd,0L,(ULONG)punit);
if(!punit->bZero)
{
//memset(punit, 0, sizeof(UNITPOP3MON));
punit->usPort = 110;
punit->szHostname[0] = '\0';
punit->bZero = 1;
punit->minutes = 5;
punit->uppr.fgColor = 0L;
punit->uppr.bgColor = 0x00CCCCCCL;
punit->termflag = FALSE;
strcpy(punit->uppr.szFont,"8.Helv");
}

punit->unit.ulRefresh = punit->minutes*60;
punit->unit.ulCounter = 0L;
punit->newmail = FALSE;
punit->state = 0;

punit->oldnmsg = punit->nmsg = 0;

SetUnitPresParam(hwnd,&punit->uppr);
WinQueryWindowRect(hwnd, &rcl);
WinSendMsg(WinQueryWindow(hwnd,QW_PARENT),WM_USER,(MPARAM)hwnd,
           (MPARAM)szPop3Help);
args[0] = punit;
args[1] = NULL;
if(DosCreateEventSem(NULL, &punit->hEventSem, NULL, TRUE))
   DosBeep( 1000, 500 );
else _beginthread(pop3scanthread, aStack, 32768, (PVOID)punit);
break;
case WM_USERTIMER:
punit->state = 0;
DosPostEventSem(punit->hEventSem);
break;
case WM_POP3STATE:
if(punit->state == POP3MON_OK)
{
punit->oldnmsg = punit->nmsg;
sscanf(punit->messagebuf,"+OK %ld %ld",&punit->nmsg, &punit->msgsize);

punit->newmail = (punit->nmsg > punit->oldnmsg);

if( punit->newmail && punit->alarmnew ) WinAlarm( HWND_DESKTOP, WA_NOTE );
if( punit->newmail && punit->runclient ) executetool(punit->szProgram, "", "");
}
WinQueryWindowRect(hwnd, &rcl);
WinInvalidateRect(hwnd, &rcl, FALSE);
break;
case WM_SPCPPC:
WinQueryWindowRect(hwnd,&rcl);
WinInvalidateRect(hwnd,&rcl,FALSE);
break;
case WM_PAINT:
GetUnitPresParam(hwnd, &punit->uppr);
hps = WinBeginPaint(hwnd, NULL, NULL);
GpiCreateLogColorTable(hps, 0L, LCOLF_RGB, 0L, 0L, (PLONG) NULL);
WinQueryWindowRect(hwnd, &rcl);
if(punit->state == POP3MON_BAD) sprintf(buf,"Error");
else
if(!punit->nmsg)sprintf(buf,"No mail");
else		sprintf(buf,"%d / %d bytes",punit->nmsg,punit->msgsize);
DrawUnitIconText(hps, &rcl, punit->newmail ? hptrPop3IconNew : hptrPop3IconEmpty,
                 buf, punit->uppr.bgColor, punit->uppr.fgColor);
WinEndPaint(hps);
return (MRESULT) NULL;
case WM_COMMAND:
switch((SHORT)mp1)
{
case 100:
WinDlgBox(HWND_DESKTOP,(HWND)mp2,(PFNWP)pop3mondlgproc,hmod,900,(PVOID)punit);
break;
case 501:
WinPostMsg(WinQueryWindow(hwnd,QW_PARENT),WM_COMMAND,(MPARAM)IDC_CONFIG,(MPARAM)NULL);
break;
case 502:
WinPostMsg(hwnd,WM_COMMAND,(MPARAM)100,(MPARAM)hwnd);
break;
case 503:
WinPostMsg(WinQueryWindow(hwnd,QW_PARENT),WM_COMMAND,(MPARAM)IDC_EXIT,(MPARAM)NULL);
break;
case 700:
punit->state = 0;
DosPostEventSem(punit->hEventSem);
break;
}
return (MRESULT) NULL;
case WM_BUTTON2CLICK:
{
POINTL ptl;

WinQueryPointerPos(HWND_DESKTOP, &ptl);
WinMapWindowPoints(HWND_DESKTOP,hwnd, &ptl, 1);
WinPopupMenu(hwnd, hwnd, hwndMailPopup, ptl.x, ptl.y, 0, PU_HCONSTRAIN   |
                                                     	 PU_VCONSTRAIN   |
                                                         PU_MOUSEBUTTON1 |
                                                   	 PU_KEYBOARD);
break;
}

case WM_DESTROY:
//free(punit);
punit->termflag = TRUE;
DosPostEventSem(punit->hEventSem);
//let monitor thread to do it by the way
break;
}
return WinDefWindowProc(hwnd,msg,mp1,mp2);
}


void pop3monregisterclass(PWCLASS pwc)
{
int i, n = 0;
char szError[256];
PVOID tmp;

DosLoadModule(szError, 256, "SO32DLL", &hmSo32);
DosLoadModule(szError, 256, "TCP32DLL", &hmTcp32);

if( ( !hmSo32 ) || ( !hmTcp32 ) )
{
DosBeep( 500, 500 );
return;
}

for( i = 0; i < 9; i++ )
{
     if( !DosQueryProcAddr( (i < 3) ? hmTcp32 : hmSo32, 0, (PSZ)aInetCalls[i],
         &tmp ) ) n++;
*aInetFuncs[i] = (PFN)tmp;
}

if( n < 9 )
{
DosBeep( 500, 500 );
return;
}

strcpy(pwc->szName,szPop3Class);
pwc->ulCfgSize = sizeof(UNITPOP3MON);
pwc->ulSafeAlloc = sizeof(UNITPOP3MON);
pwc->bInitalUnitWidthPercent = 10;
WinRegisterClass(habMain,(PSZ)szPop3Class,(PFNWP)pop3monwndproc,CS_SIZEREDRAW,8L);
hptrPop3IconEmpty = WinLoadPointer(HWND_DESKTOP,hmod,303);
hptrPop3IconNew = WinLoadPointer(HWND_DESKTOP,hmod,304);
hwndMailPopup = WinLoadMenu(HWND_DESKTOP,hmod,700);
}
