/* REXX installation script for Systray/2
 * Copyright (C) 2000 by Ilfat Kutdusov
 * Modified by Dmitry Zakharov 29/12/2000
 */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/*------------------------------------------------------------------
 * Initialization 
 *------------------------------------------------------------------*/

installdir = directory()"\"
installlog = installdir"install.log"

if GetYesNo( "Install Systray/2 in" installdir ) == 0 then
   exit

/*------------------------------------------------------------------
 * Create folder
 *------------------------------------------------------------------*/

rc = SysCreateObject( "WPFolder","Systray/2","<WP_DESKTOP>",,
                      "OBJECTID=<WPSystrayFolder>;ALWAYSSORT=Yes" ,"REPLACE" )
if rc then call log "Systray/2 folder successfully created on desktop..."
else       call log "ERROR: Systray/2 folder creating failed!"

rc = SysCreateObject("WPShadow","Russian Docs","<WPSystrayFolder>","SHADOWID="installDir"Russian.doc","Replace")
if rc then    call log "Systray/2 Rdocs shadow successfully created..."
   else       call log "Systray/2 Rdocs shadow  creating failed!"


rc = SysCreateObject("WPShadow","Sources","<WPSystrayFolder>","SHADOWID="installDir"Sources","Replace")
if rc then    call log "Sources shadow successfully created..."
   else       call log "Sources shadow  creating failed!"


/*------------------------------------------------------------------
 * Create object
 *------------------------------------------------------------------*/

rc = SysCreateObject( "WPProgram", "Systray/2", "<WPSystrayFolder>",,
                      "OBJECTID=<WPSystray>;EXENAME="installdir"systray2.exe;STARTUPDIR="installdir";REPLACE" )
if rc then       call log "Systray/2 object successfully created..."
  else           call log "ERROR: Systray/2 object creating failed!"


rc = SysCreateObject( "WPProgram", "System tray Example", "<WPSystrayFolder>",,
                      "OBJECTID=<WPSystrayTrayEx>;EXENAME="installdir"trayex.exe;STARTUPDIR="installdir";REPLACE" )
if rc then       call log "System tray Example object successfully created..."
  else           call log "ERROR: System tray Example object creating failed!"


rc = SysCreateObject( "WPProgram", "Systray Guide", "<WPSystrayFolder>",,
                      "OBJECTID=<SystrayReadme>;EXENAME=view.exe;PARAMETERS="installdir"systray.inf;STARTUPDIR="installdir";REPLACE" )
if rc then    call log "Reference object successfully created..."
   else       call log "ERROR: Reference object creating failed!"


rc = SysCreateObject( "WPShadow", "Systray/2", "<WP_START>",,
                      "SHADOWID=<WPSystray>",,
                      "REPLACE" )
if rc then    call log "Systray/2 object shadow added in Startup folder..."
   else       call log "Systray/2 object shadow adding in Startup folder failed!"




/*------------------------------------------------------------------
 * Create object
 *------------------------------------------------------------------*/




Exit

/*------------------------------------------------------------------
 * Get Yes or No
 *------------------------------------------------------------------*/
GetYesNo: procedure

   ok = 0

   do until ok
      call charout, arg(1) || "? "
      pull reply
      reply = left(reply, 1)
      ok = (reply = "Y") | (reply = "N")
      if \ok then do
         say 'Huh? Please enter "Y" or "N".'
      end
   end

return (reply = "Y")

/*------------------------------------------------------------------
 * Write log message
 *------------------------------------------------------------------*/
Log: procedure expose installlog; parse arg msg

   say  " "msg
   call lineout installlog, "INSTALL: "msg

return
